ENTRY(xen_hypervisor_callback)
	zeroentry do_hypervisor_callback
ENDPROC(xen_hypervisor_callback)

ENTRY(xen_failsafe_callback)
	/*FIXME: implement me! */
	ud2a
ENDPROC(xen_failsafe_callback)


/*
 * Copied from arch/xen/i386/kernel/entry.S
 */               
# A note on the "critical region" in our callback handler.
# We want to avoid stacking callback handlers due to events occurring
# during handling of the last event. To do this, we keep events disabled
# until we've done all processing. HOWEVER, we must enable events before
# popping the stack frame (can't be done atomically) and so it would still
# be possible to get enough handler activations to overflow the stack.
# Although unlikely, bugs of that kind are hard to track down, so we'd
# like to avoid the possibility.
# So, on entry to the handler we detect whether we interrupted an
# existing activation in its critical region -- if so, we pop the current
# activation and restart the handler using the previous one.
ENTRY(do_hypervisor_callback)   # do_hypervisor_callback(struct *pt_regs)
	CFI_STARTPROC
# Since we don't modify %rdi, evtchn_do_upall(struct *pt_regs) will
# see the correct pointer to the pt_regs
	movq %rdi, %rsp            # we don't return, adjust the stack frame
	CFI_ENDPROC
	CFI_DEFAULT_STACK
11:	incl %gs:pda_irqcount
	movq %rsp,%rbp
	CFI_DEF_CFA_REGISTER rbp
	cmovzq %gs:pda_irqstackptr,%rsp
	pushq %rbp			# backlink for old unwinder
	call xen_evtchn_do_upcall
	popq %rsp
	CFI_DEF_CFA_REGISTER rsp
	decl %gs:pda_irqcount
	jmp  error_exit
	CFI_ENDPROC
END(do_hypervisor_callback)


ENTRY(xen_retint_swapgs)		/* return to user-space */
	/*
	 * The iretq could re-enable interrupts:
	 */
	DISABLE_INTERRUPTS(CLBR_ANY)
	TRACE_IRQS_IRETQ
	jmp restore_args
END(xen_retint_swapgs)


ENTRY(xen_system_call_entry)
	CFI_STARTPROC	simple

	//FIXME: CFI directives here

	// We need additional space for orig_ax.
	// That would be SAVE_ARGS 8, but we already have
	// r11 and rcx saved on the stack
	SAVE_ARGS -8

	jmp system_call_after_saveargs
	CFI_ENDPROC
END(xen_system_call_entry)
